/*
Part of the algoviz@vt collection of algorithm visualizations.
Copyright (C) 2007  Virginia Tech Department of Computer Science

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
import java.io.*;

public class LfuAlgorithm 
{
  int diskSpace[];
  int MainMemory[];
  int Access[];
  int MainMemoryP;
  boolean IsInMemory;
  
  public LfuAlgorithm ( int [] dS, int[] mM, int aC[] )
  {
  	diskSpace = dS;
  	MainMemory = mM;
  	Access = aC;
  	IsInMemory = false;
  }
  
  public void InputElement ( int a, int Pointer )
  {
  	int AnElement = a;
  	MainMemoryP = Pointer;
  	int Index =-1;
  	int MinAccess = 0;
  	int position = -1;
  	
  	Access [AnElement]++;

  	for  ( int i=0; i < MainMemoryP; i++ )
  	{
  	  if ( MainMemory [i] == AnElement )
  	    {
  	      IsInMemory = true;
  	      Index = i;
  	    }    	    
  	}
 
// If the element is in Memory............ 
  	if ( IsInMemory == true )
  	{
  	  int j =0;
  	  while ( j < 4 )
  	  {
  	  	if ( Access[AnElement] < Access[MainMemory [j] ] )
  	  	  j++;

  	  	else
  	  	  break;
  	  }
  	  
  	  position = j;
  	    	  
  	  for ( int i = Index; i > position; i-- )
  	    MainMemory [i] = MainMemory [i-1];
  	    
  	  MainMemory [position] = AnElement;
    }
    
// If the element is not in the memory and the value of Main Pointer is less than 5..    
  	
    if ( ( MainMemoryP < 5 ) && ( IsInMemory == false ) )
    {
      int j =0;

      if  ( MainMemoryP != 0 )
  	  {  
  	    while ( j < 4 )
  	    {
  	      if ( MainMemory [j] != -1 )
  	  	  {
  	        if ( Access[AnElement] < Access[MainMemory [j] ] )
  	  	    {
  	  	      j++;
  	  	    }
  	  	    else
  	  	      break;
  	  	  }
  	    }
  	  }
  	  
  	  position = j;
  	    	  
      for ( int i= MainMemoryP; i> position; i-- )
      {
      	MainMemory [i] = MainMemory [i-1];
      }
      
      MainMemory [ position ] = AnElement;
      diskSpace[AnElement] = 1;
    }
    
    else if ( IsInMemory == false ) 
    {      
      int pos =0;      
      while ( pos < 4 )
      {
      	if ( Access[AnElement] < Access[MainMemory [pos] ] )
      	 pos++;
       	else
          break;
      }
            
      for ( int i = 4; i > pos; i-- )
      {
      	MainMemory [i] = MainMemory [i-1];
      }
      MainMemory [pos] = AnElement;      
    }
  }

/***********************************************************************/
/* Returns the value if the Element is in Memory*/
/***********************************************************************/

  public boolean IsElementInMemory ( int AnElement, int pointer )
  {
  	boolean isElement = false;
  	for ( int i=0; i < pointer; i++ )
  	{
  	  if ( MainMemory [i] == AnElement )
  	  {
  	  	isElement = true;
  	  }
  	}
  	
  	return isElement;
  }
  
  public int Index ( int AnElement, int pointer )
  {
  	 
 	 int index=0;

  	 for ( int i=0; i < pointer; i++ )
  	 {
  	   if ( MainMemory [i] == AnElement )
  	   {
  	 	 index = i;
  	   }
  	 }
  	 
  	 return index;  	 
  }
  
  public void ResetIsInMemory ( boolean value )
  {
  	IsInMemory = value;
  }
  
}